
require "Win32API"


module Midi
=begin
  midio͂Ƃ舵NXQB
  Ƃ肠win32ŁB

  ruby 1.3.4-990625 [i386-cygwin]ŊmFB
  ̔łɓYtĂWin32API.DLLł͓ȂB
  http://blade.nagaokaut.ac.jp/cgi-bin/scat.rb/ruby/ruby-dev/8622
  ȂǂɏĂ悤ɁAruby 1.4.3 p̓DLLɍւ
  悤B
  ruby 1.4.3 [i386-cygwin]ŊmFB

  
  19991215 A.(Y) B

  NX
    MidiOut
      Midio͂NX

=end



  class MidiOut
=begin
  MidiOut[q()bv悤ȃIuWFNgB
  Midio͂B
  Ƃ肠ShortMessage(exclusiveȊO)݂̂̏o͂ΉB

  
  19991215 A.(Y)
    B
  20000217 A.(Y)
    devNameunpack̂ǂB32{Ă̂̓iVׂB
    B

  NX\bh
    new
      CX^XB邾ȂMidiOut[qؐLȂB
  CX^X\bh
    numDevs
      ̌vZ@installĂMidiOut[q̐Ԃ
    devName(devid)
      devidԖڂMidiOut[q̖ԂBdevid-1ȏnumDevs̐
      (-1MIDI_MAPPERƂČŒ肳Ă)
    devNames
      ̌vZ@installĂMidiOut[q̖S(MIDI_MAPPER
      ܂߂ĂȂ)zԂ
    open(devid)
      devidԖڂMidiOut[qJBɊJĂJ˂
      Ƃ͗OɂȂBhCo̎ɂĂ
      MidiOutIuWFNg(܂͑̃Av)瓯ɊJƂ
      Ă苖ĂȂ肷BĂȂꍇ
      ʁXMidiOutIuWFNgœԍ̒[qJƂ
      ON邾낤B
      (ĂhCo𑭂MultiCliantΉƌĂԂ炵)
    opened
      openĂ邩ǂԂB
    devid
      ̃CX^XJĂMidiOut[q̔ԍ(DeviceID)ԂB
      ԍopen̈̒lBJĂȂƂnilԂB
    close
      JĂΕBJĂłȂΓɂȂɂȂB
    out(mes)
      ShortMessageo͂Bmes͏o͂midibZ[W
      Microsoft̃}`fBAAPI̗VpackB
        lFExclusiveMessageLongMessageƌĂсAȊOShortMessageƌĂсA
        XShortMessage𐮐packAƂVMicrosoftɕB
        ̂肩̓RXgIɂÓȂ̂ƎvB
        ShortMessageuMessage̐sbyte𐮐̉byteɁvĂ
        MS̗V́ARubył͂܂ƂɐFixnumł邽߂̏
        ɖĂĂB(ShortMessage3byteȂ̂ŁAʂ
        Ăΐ΂ɍŏbit͗ȂBʂ犄Ă
        ShortMessage1byteڂ͕KŏbitĂ(StatusByte)̂
        KBigNumɂȂĂ܂)
        ̓CX^Xł̃RXgCɂɍςނƂƂB
        ܘ_Messageuvꍇ͂ĂȂ낤B
        ̌`͂Ȃ̂ŁÅpMidiW[Ƃ
        Ă܂̂̂ł͂ȂƎvB
=end

    attr :opened
    attr :devid

    def initialize
      @opened=false
      @devid=nil
      @handle=nil
      @midiOutGetNumDevs = Win32API.new("winmm", "midiOutGetNumDevs", [], 'L')
      @midiOutGetDevCaps = Win32API.new("winmm", "midiOutGetDevCaps",
          ['L', 'P', 'L'], 'L')
      @midiOutOpen = Win32API.new("winmm", "midiOutOpen",
          ['P', 'L', 'L', 'L', 'L'], 'L')
      @midiOutClose = Win32API.new("winmm", "midiOutClose", ['L'], 'L')
      @midiOutShortMsg = Win32API.new("winmm", "midiOutShortMsg", ['L', 'L'], 'L')
    end

    def numDevs
      @midiOutGetNumDevs.Call
    end
    def devName(devid)
      buf=' ' * 60
      result=@midiOutGetDevCaps.Call(devid, buf, buf.size) #52byte or more
      if result != 0
        raise "midiOutGetDevCaps error"
      end
      #mid,pid,ver,name = buf.unpack("ssLa")
      #buf.unpack("x"*8 + "a"*32).join('').split("\0")[0]
      buf.unpack("x"*8 + "a*").join('').split("\0")[0]
    end
    def devNames
      a=[]
      (0...numDevs).each{|i|
        a<<devName(i)
      }
      a
    end

    def open(devid)
      if @opened; raise "already opened"; end
      handlebuf=' ' * 4
      result=@midiOutOpen.Call(handlebuf, devid, 0, 0, 0)
      if result != 0; raise "midiOutOpen error"; end
      @handle=handlebuf.unpack("L")[0]
      #printf "%x", @handle
      @opened=true
      @devid=devid
    end

    def close
      if @opened
        result=@midiOutClose.Call(@handle)
        if result != 0; raise "midiOutClose error"; end
      end
      @handle=nil
      @opened=false
      @devid=nil
    end

    def out(mes)
      if ! @opened; raise "not opened"; end
      result=@midiOutShortMsg.Call(@handle, mes)
      if result != 0; raise "midiOutShortMsg error"; end
    end

  end

end


if __FILE__ == $0
  include Midi

  a=MidiOut.new
  b=MidiOut.new
  a.devNames.each{|name|
    p name
  }

  a.open 0
  sleep 1
  a.out 0x704090 #type=noteon, ch=0, notenum=0x40, velocity=0x70
  sleep 0.5
  a.out 0x004090 #type=noteoff, ch=0, notenum=0x40, velocity=0x00
  sleep 1
  a.close

end

