#!/usr/local/bin/ruby -w
# by Kouichirou@Eto.com 2001/10/01

require 'midiout'
require 'midiin'
include Midi

module SGL
  Thread.abort_on_exception = true
  $min = MidiIn.new

  def $min.onMidiIn(mes)
    #p ["test", mes]
    status = mes & 0xff
    statustype = status & 0xf0
    ch = status & 0x0f
    data1 = (mes >>  8 ) & 0x7f
    data2 = (mes >> 16 ) & 0x7f
    if statustype == 0x90 #noteon
      if data2 == 0
	onMidiOff(ch, data1)
      else
	onMidiOn(ch, data1, data2)
      end
    elsif statustype == 0x80 #noteoff
      onMidiOff(ch, data1)
    end
  end

  p $min.devNames
  $min.open 1
  $min_thread = Proc.new {
    MidiIn.waitloop
  }

  #----------------------------------------------------------------------֐
end

#----------------------------------------------------------------------I
