require 'sdl'

SDL.init( SDL::INIT_VIDEO )

screen = SDL::setVideoMode(640,480,16,SDL::SWSURFACE)
SDL::WM::setCaption($0,$0)

SDL::TTF.init

if /(mingw32|mswin32)/ === RUBY_PLATFORM
  font = SDL::TTF.open(ENV['WINDIR'] + '\Fonts\msgothic.ttc',24)
elsif /cygwin/ === RUBY_PLATFORM
  font = SDL::TTF.open('' + ENV['WINDIR'].gsub(/\\\\/,'/').delete(':') + 'Fonts/msgothic.ttc',24)
else
  font = SDL::TTF.open('font.ttf',24)
end
font.style = SDL::TTF::STYLE_NORMAL

font.drawSolidUTF8(screen,'test SDL_ttf',300,150,255,255,255)

screen.flip

event=SDL::Event.new

while true 
  if  event.poll != 0 then
    if event.type==SDL::Event::QUIT then
      break
    end
    if event.type==SDL::Event::KEYDOWN then
      exit
    end
  end
end
